window.onload = init;

function init() {
    new Vue({
        el: "#app", // l'element HTML qui contient la vue
        data: { // les modèles
            restaurants: [],
            count: 0,
            nom: "",
            cuisine: "",
            page: 0,
            pagesize: 10,
            nomRecherche: ""
        },
        mounted() { // appelé avant affichage
            console.log("avant affichage");
            this.getRestaurants()
        },
        methods: {
            getRestaurants() {
                let url = "http://localhost:8085/api/restaurants?page=" +
                    this.page +
                    "&pagesize=" + this.pagesize +
                    "&nom=" + this.nomRecherche;

                fetch(url)
                    .then((data) => {
                        // reponse en JSON, on transforme en objet JS
                        return data.json();
                    }).then((reponse) => {
                        console.log(reponse.msg);
                        // les restaurants sont dans response.data
                        this.restaurants = reponse.data;
                        this.count = reponse.count;
                    }).catch((err) => {
                        console.log(err);
                    })
            },
            ajouterRestaurant() {
                console.log("Ajout du restaurant " + this.nom);
                // 1 on supprime le comportement par defaut du navigateur
                // qui soumet le form et re affiche une page après

                // 2 On recupere le formulaire

                // 3 on recupere tout le contenu

                // 4 on envoie les données en ajax au serveur
            },
            supprimerRestaurant(r) {
                console.log("je supprime le restaurant " + r._id);
                // on envoie une requete DELETE sur api/restaurant/id
            },
            pagePrecedente() {
                if (this.page != 0)
                    this.page--;

                this.getRestaurants();
            },
            pageSuivante() {
                this.page++;
                this.getRestaurants();
            }
        }
    });
}