var MongoClient = require('mongodb').MongoClient;
// Connection URL
const url = 'mongodb://localhost:27017';

// Database Name
const dbName = 'test';

exports.findRestaurants = function findRestaurants(page, pagesize, nom, cuisine, callback) {
    console.log("page = " + page + " pagesize = " + pagesize);
    MongoClient.connect(url, (err, client) => {
        // On est connecté à la base
        var db = client.db(dbName);
        
        let query = {}; // requete vide = select * de base...

        if(nom != "") {
            // recherche par nom
            // syntaxe recommandée
            // Cf doc mongodb: https://docs.mongodb.com/manual/reference/operator/query/regex/
            // The $regex value needs to be either the string 
            // pattern to match or a regular expression object. 
            // When passing a string pattern, you don't include 
            // the / delimitters
            // VERSION avec $regexp et $options
            query = {
                "name": {
                    $regex: ".*" + nom + ".*",
                    $options: "i"
                }
            }
        }
        if (!err) {
            db.collection('restaurants')
                .find(query)
                .limit(parseInt(pagesize))
                .skip(parseInt(page*pagesize))
                .toArray()
                .then(resultats => {
                    db.collection('restaurants')
                    .find(query)
                    .count()
                    .then((count) => {
                        callback(resultats, count);
                    })
                    
                });
        } else {
            callback(-1);
        }
    });
};